require 'singleton'

module ProxyAuth
  # Service token
  class Token
    include Singleton

    attr_accessor :token

    def initialize
      register_service
    end

    def register_service
      Thread.new do
        set_token
      end
    end

    def valid?(token)
      @token == token
    end

    private

    def set_token
      connection = Connection.new
      3.times do
        @token ||= connection.service_token
        @token && break || sleep(5)
      end
    end
  end
end
